// package klepto;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.NumberFormatter;
import java.text.ParseException;
import java.text.DecimalFormat;
import java.net.URL;
import java.util.Hashtable;

public class Display extends JFrame {
	JPanel panel;
	JTextField round;
	JTextField clock;
	Hashtable treasure,
		alarms;
	JTextArea area;
	Hashtable players;

	public Display(String title) {
		super(title);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(800,600);
//  		Container pane = frame.getContentPane();

		initNames();

		panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.PAGE_AXIS));
// 		panel = new JPanel(new GridLayout(3,1));

		JPanel toprow = new JPanel(new GridLayout(1,3));

		Font font = new Font("Helvetica", Font.BOLD, 24);

		TitledBorder border = BorderFactory.createTitledBorder("Round");
		border.setTitleJustification(TitledBorder.CENTER);
		JPanel comp = new JPanel(new GridLayout(1,1), false);
		round = new JTextField();
		round.setFont(font);
		round.setHorizontalAlignment(JTextField.CENTER);
		round.setEditable(false);
		round.setBackground(Color.YELLOW);
		comp.add(round);
		comp.setBorder(border);
		toprow.add(comp);

		ImageIcon icon = createImageIcon("urcs.jpg", "Round: ");
		JButton jb = new JButton(icon);
		toprow.add(jb);

		border = BorderFactory.createTitledBorder("Clock");
		border.setTitleJustification(TitledBorder.CENTER);
		comp = new JPanel(new GridLayout(1,1), true);
		comp.setBorder(border);
		clock = new JTextField();
		clock.setFont(font);
		clock.setHorizontalAlignment(JTextField.CENTER);
		clock.setEditable(false);
		comp.add(clock);
		toprow.add(comp);

// 		pane.add(toprow, BorderLayout.PAGE_START);
		panel.add(toprow);

		border = BorderFactory.createTitledBorder("Messages");
// 		border = BorderFactory.createEtchedBorder();
		comp = new JPanel(new GridLayout(1,1), false);
		comp.setBorder(border);
		area = new JTextArea("* KLEPTO DISPLAY: READY", 20, 40);
		area.setAutoscrolls(true);
		area.setEditable(false);
		comp.add(area);
// 		pane.add(comp);
		panel.add(comp);

		setPeriod("0");
		setRound("1");
		setClock("15");

		JPanel teams = new JPanel(new GridLayout(1,3));
		font = new Font("Helvetica", Font.BOLD, 12);

		int align = JLabel.LEFT;

		border = BorderFactory.createTitledBorder("Red team");
		border.setTitleColor(Color.red);
		JPanel redteam = new JPanel(new GridLayout(6,2));
		redteam.setBorder(border);
		// score and alarms
		JPanel small1 = new JPanel(new GridLayout(1,2));
		icon = createImageIcon("treasure.gif", "Treasure");
		JLabel jl = new JLabel(icon);
		small1.add(jl);
		small1.add((JLabel)treasure.get("red"));
		icon = createImageIcon("alert-black.gif", "Alarms");
		jl = new JLabel(icon);
		JPanel small2 = new JPanel(new GridLayout(1,2));
		small2.add(jl);
		small2.add((JLabel)alarms.get("red"));
		redteam.add(small1);
		redteam.add(small2);
		// matt
		JLabel label = new JLabel("Matt", align);
		label.setFont(font);
		redteam.add(label);
		redteam.add((JLabel)players.get("matt"));
		// arrvindh
		label = new JLabel("Arrvindh", align);
		label.setFont(font);
		redteam.add(label);
		redteam.add((JLabel)players.get("arrvindh"));
		// ross
		label = new JLabel("Ross", align);
		label.setFont(font);
		redteam.add(label);
		redteam.add((JLabel)players.get("ross"));
		// shiva
		label = new JLabel("Shiva", align);
		label.setFont(font);
		redteam.add(label);
		redteam.add((JLabel)players.get("shiva"));
		// ding
		label = new JLabel("Ding", align);
		label.setFont(font);
		redteam.add(label);
		redteam.add((JLabel)players.get("ding"));

		teams.add(redteam);

		border = BorderFactory.createTitledBorder("Green team");
		border.setTitleColor(Color.green);
		JPanel greenteam = new JPanel(new GridLayout(6,2));
		greenteam.setBorder(border);
		// score and alarms
		small1 = new JPanel(new GridLayout(1,2));
		icon = createImageIcon("treasure.gif", "Treasure");
		jl = new JLabel(icon);
		small1.add(jl);
		small1.add((JLabel)treasure.get("green"));
		icon = createImageIcon("alert-black.gif", "Alarms");
		jl = new JLabel(icon);
		small2 = new JPanel(new GridLayout(1,2));
		small2.add(jl);
		small2.add((JLabel)alarms.get("green"));
		greenteam.add(small1);
		greenteam.add(small2);
		// jacob
		label = new JLabel("Jacob", align);
		label.setFont(font);
		greenteam.add(label);
		greenteam.add((JLabel)players.get("jacob"));
		// piotr
		label = new JLabel("Piotr", align);
		label.setFont(font);
		greenteam.add(label);
		greenteam.add((JLabel)players.get("piotr"));
		// mike
		label = new JLabel("Mike", align);
		label.setFont(font);
		greenteam.add(label);
		greenteam.add((JLabel)players.get("mike"));
		// wenzhao
		label = new JLabel("Wenzhao", align);
		label.setFont(font);
		greenteam.add(label);
		greenteam.add((JLabel)players.get("wenzhao"));

		teams.add(greenteam);
		
		border = BorderFactory.createTitledBorder("Blue team");
		border.setTitleColor(Color.blue);
		JPanel blueteam = new JPanel(new GridLayout(6,2));
		blueteam.setBorder(border);
		// score and alarms
		small1 = new JPanel(new GridLayout(1,2));
		icon = createImageIcon("treasure.gif", "Treasure");
		jl = new JLabel(icon);
		small1.add(jl);
		small1.add((JLabel)treasure.get("blue"));
		icon = createImageIcon("alert-black.gif", "Alarms");
		jl = new JLabel(icon);
		small2 = new JPanel(new GridLayout(1,2));
		small2.add(jl);
		small2.add((JLabel)alarms.get("blue"));
		blueteam.add(small1);
		blueteam.add(small2);
		// anustup
		label = new JLabel("Anustup", align);
		label.setFont(font);
		blueteam.add(label);
		blueteam.add((JLabel)players.get("anustup"));
		// tanushree
		label = new JLabel("Tanushree", align);
		label.setFont(font);
		blueteam.add(label);
		blueteam.add((JLabel)players.get("tanushree"));
		// ben
		label = new JLabel("Ben", align);
		label.setFont(font);
		blueteam.add(label);
		blueteam.add((JLabel)players.get("ben"));
		// pin
		label = new JLabel("Pin", align);
		label.setFont(font);
		blueteam.add(label);
		blueteam.add((JLabel)players.get("pin"));
		// lior
		label = new JLabel("Lior", align);
		label.setFont(font);
		blueteam.add(label);
		blueteam.add((JLabel)players.get("lior"));
		teams.add(blueteam);

// 		pane.add(teams, BorderLayout.LINE_END);
		panel.add(teams);

        getContentPane().add(panel, BorderLayout.CENTER);
		pack();
		setVisible(true);
	}


	private void initNames() {
		String s = "~";
		JLabel l;
		int align = JLabel.RIGHT;

		players = new Hashtable();
		l = new JLabel(s, align);
		players.put("matt", l);
		l = new JLabel(s, align);
		players.put("anustup", l);
		l = new JLabel(s, align);
		players.put("shiva", l);
		l = new JLabel(s, align);
		players.put("arrvindh", l);
		l = new JLabel(s, align);
		players.put("ben", l);
		l = new JLabel(s, align);
		players.put("mike", l);
		l = new JLabel(s, align);
		players.put("piotr", l);
		l = new JLabel(s, align);
		players.put("pin", l);
		l = new JLabel(s, align);
		players.put("ding", l);
		l = new JLabel(s, align);
		players.put("wenzhao", l);
		l = new JLabel(s, align);
		players.put("jacob", l);
		l = new JLabel(s, align);
		players.put("lior", l);
		l = new JLabel(s, align);
		players.put("ross", l);
		l = new JLabel(s, align);
		players.put("tanushree", l);

		s = "0";
		align = JLabel.CENTER;
		treasure = new Hashtable();
		JLabel tf = new JLabel(s,align);
		treasure.put("red", tf);
		tf = new JLabel(s,align);
		treasure.put("blue", tf);
		tf = new JLabel(s,align);
		treasure.put("green", tf);
		alarms = new Hashtable();
		tf = new JLabel(s,align);
		alarms.put("red", tf);
		tf = new JLabel(s,align);
		alarms.put("blue", tf);
		tf = new JLabel(s,align);
		alarms.put("green", tf);

	}		

	public void setAlarm(String team, String count) {
		try {
			((JLabel)alarms.get(team)).setText(count);
		} catch (NullPointerException e) {
			System.out.println("* Got invalid team name '"+team+"'");
		}
	}

	public void setTreasure(String team, String count) {
		try {
			((JLabel)treasure.get(team)).setText(count);
		} catch (NullPointerException e) {
			System.out.println("* Got invalid team name '"+team+"'");
		}
	}

	public void setPeriod(String p) {
		Color color = null;

		if (p.equals("0"))
			color = Color.red;
		else if (p.equals("1"))
			color = Color.blue;
		else if (p.equals("2"))
			color = Color.green;
		else if (p.equals("3"))
			color = Color.yellow;
		else
			color = Color.white;

		round.setBackground(color);
		clock.setBackground(color);
	}

	public void setRound(String r) {
		round.setText(r);
	}

	public void setClock(String s) {
		clock.setText(s);
	}

	public void append(String msg) {
		area.append(msg+"\n");
	}

	public void append(String team, String msg) {
		area.append(team.toUpperCase()+": "+msg+"\n");

	}

	public void setStatus(String player, String status) {
		JLabel label = (JLabel)players.get(player);
		if (null == label) {
			append("* Got invalid player name "+player);
			return;
		}

		label.setText(status);
	}

    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path,
                                               String description) {
        java.net.URL imgURL = Display.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL, description);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }

	public static void main(String args[]) {
		JFrame.setDefaultLookAndFeelDecorated(true);
		Display display = new Display("KLEPTOMANIA GAME STATUS");

		TimeRegistrar tr = null;
		if (args.length > 0)
			tr = new TimeRegistrar(args[0]);
		else
			tr = new TimeRegistrar();
		while (! tr.registered()) {
			tr.register();
			try {
				Thread.sleep(1000);
			} catch (Exception e) {
				System.out.println(e.getMessage());
				e.printStackTrace();
			}
		}

		Server s = new Server(display);
		s.listenSocket();
	}
}
