import java.io.*;
import java.net.*;

class UTFTelnet
{
	private String server = null;
	private int port = 0;
	private UpdateDisplay us = null;

	public UTFTelnet() {
		server = "localhost";
		this.port = 9990;
		us = new UpdateDisplay(server);
	}

	public UTFTelnet(int port) {
		server = "localhost";
		this.port = port;
		us = new UpdateDisplay(server);
	}

	public UTFTelnet(String host, int port) {
		server = host;
		this.port = port;
		us = new UpdateDisplay(server);
	}

	public void send(String what) {
		us.update(what);
    }

	public static void main(String args[]) {
		if (args.length != 2) {
			System.out.println("Usage: UTFTelnet <server> <port>");
			System.exit(-1);
		}

		UTFTelnet telnet = new UTFTelnet(args[0],
										 new Integer(args[1]).intValue());

		String line = "";
		while (true) {
			System.out.println("Type quit to quit.");
			System.out.print("String to send: ");
			try {
				BufferedReader in = new BufferedReader(
									    new InputStreamReader(System.in));
				line = in.readLine();
				if (line.equals("quit"))
					break;

				telnet.send(line);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
